Ruby - Bug #20496

Segfault when enabling YJIT
05/19/2024 11:59 AM - gettalong (Thomas Leitner)

Status: Closed
Priority: Normal
Assignee: jit

Target version:

ruby -v: ruby 3.4.0dev (2024-05-19T03:08:35Z Backport: 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3:

master 7afc16aa48) [x86_64-linux] DONE

Description

| installed Ruby 3.4-dev via rbenv to see how the improvements in YJIT with 3.4-dev (after reading
https://speakerdeck.com/kOkubun/rubykaigi-2024) translate to other parts of HexaPDF. However, when running the HexaPDF
optimization benchmark with YJIT enabled, it regularly segfaults. This does not happen without YJIT.

Steps to reproduce

Clone the HexaPDF repository: git clone git@github.com:gettalong/hexapdf.git

Download the file a.pdf attached to this issue into the hexapdf directory.

Change into the hexapdf directory and run ruby --yjit - lib bin/hexapdf -f optimize --compress-pages a.pdf out.pdf.
The run may not fail every time but it does fail with a segfault many times.

Segfault output

/tmp/hexapdf/lib/hexapdf/task/optimize.rb:289: [BUG] Segmentation fault at 0x00000000000000b0
ruby 3.4.0dev (2024-05-19T03:08:35Z master 7afcl6aad48) +YJIT [x86_64-1linux]

-— Control frame information —---———-—-----"-"---—-——————————————————————————

c:0024 p:0016 s:0147 e:000142 METHOD /tmp/hexapdf/lib/hexapdf/task/optimize.rb:289
c:0023 p:0042 s:0136 :000135 BLOCK /tmp/hexapdf/lib/hexapdf/content/parser.rb:192
c:0022 p:0017 s:0132 e:000131 METHOD <internal:kernel>:191

c:0021 p:0067 s:0127 e:000126 METHOD /tmp/hexapdf/lib/hexapdf/content/parser.rb:186
c:0020 p:0016 s:0118 e:000117 METHOD /tmp/hexapdf/lib/hexapdf/content/parser.rb:166
c:0019 p:0018 s:0111 E:002198 BLOCK /tmp/hexapdf/lib/hexapdf/task/optimize.rb:241
c:0018 p:0015 s:0105 e:000104 BLOCK /tmp/hexapdf/lib/hexapdf/type/page_tree_node.rb:243
c:0017 p:0007 s:0101 e:000100 BLOCK /tmp/hexapdf/lib/hexapdf/pdf_array.rb:183 [FINISH]
c:0016 p:———— s:0097 €:000096 CFUNC :each_index

c:0015 p:0018 s:0093 e:000092 METHOD /tmp/hexapdf/lib/hexapdf/pdf_array.rb:183

c:0014 p:0020 s:0089 e:000088 METHOD /tmp/hexapdf/lib/hexapdf/type/page_tree_node.rb:241
c:0013 p:0013 s:0084 e:000083 METHOD /tmp/hexapdf/lib/hexapdf/document/pages.rb:178
c:0012 p:0011 s:0079 E:0015a0 METHOD /tmp/hexapdf/lib/hexapdf/task/optimize.rb:236
c:0011 p:0009 s:0073 e:000072 METHOD /tmp/hexapdf/lib/hexapdf/task/optimize.rb:87

c:0010 p:0024 s:0061 e:000060 METHOD /tmp/hexapdf/lib/hexapdf/document.rb:570

c:0009 p:0031 s:0053 e:000052 METHOD /tmp/hexapdf/lib/hexapdf/cli/command.rb:276

c:0008 p:0011 s:0048 e:000047 BLOCK /tmp/hexapdf/lib/hexapdf/cli/optimize.rb:76

c:0007 p:0059 s:0044 e:000043 METHOD /tmp/hexapdf/lib/hexapdf/cli/command.rb:101

c:0006 p:0017 s:0033 e:000032 METHOD /tmp/hexapdf/lib/hexapdf/cli/optimize.rb:74

c:0005 p:0288 s:0027 €:000026 METHOD /home/thomas/.rbenv/versions/3.4-dev/1lib/ruby/gems/3.4.0+0/ge
ms/cmdparse-3.0.7/1ib/cmdparse.rb:889

c:0004 p:0023 s:0017 e:000016 METHOD /tmp/hexapdf/lib/hexapdf/cli.rb:146

c:0003 p:0012 s:0012 e:000011 METHOD /tmp/hexapdf/lib/hexapdf/cli.rb:63

c:0002 p:0010 s:0006 e:000005 EVAL bin/hexapdf:6 [FINISH]

c:0001 p:0000 s:0003 E:000590 DUMMY [FINISH]

—-— Ruby level backtrace information --———-—---"-"""""""""""""“"—"—"—"—"—"—————————
bin/hexapdf:6:in '<main>'

/tmp/hexapdf/lib/hexapdf/cli.rb:63:in 'run'
/tmp/hexapdf/lib/hexapdf/cli.rb:146:in 'parse'

/home/thomas/.rbenv/versions/3.4-dev/1ib/ruby/gems/3.4.0+0/gems/cmdparse-3.0.7/1ib/cmdparse.rb:889

:in 'parse'
/tmp/hexapdf/lib/hexapdf/cli/optimize.rb:74:in 'execute'
/tmp/hexapdf/lib/hexapdf/cli/command.rb:101:in
/tmp/hexapdf/lib/hexapdf/cli/optimize.rb:76:1in
/tmp/hexapdf/lib/hexapdf/cli/command.rb:276:in 'apply_ optimization_options'
/tmp/hexapdf/lib/hexapdf/document.rb:570:in 'task'
/tmp/hexapdf/lib/hexapdf/task/optimize.rb:87:in 'call'
/tmp/hexapdf/lib/hexapdf/task/optimize.rb:236:in 'compress_pages'
/tmp/hexapdf/lib/hexapdf/document /pages.rb:178:in 'each'
/tmp/hexapdf/lib/hexapdf/type/page_tree_node.rb:241:in 'each_page'
/tmp/hexapdf/lib/hexapdf/pdf_array.rb:183:in
/tmp/hexapdf/lib/hexapdf/pdf_array.rb:183:in 'each_index'
/tmp/hexapdf/lib/hexapdf/pdf_array.rb:183:in 'block in each'
/tmp/hexapdf/lib/hexapdf/type/page_tree_node.rb:243:in 'block in each_page'
/tmp/hexapdf/lib/hexapdf/task/optimize.rb:241:in 'block in compress_pages'
/tmp/hexapdf/lib/hexapdf/content/parser.rb:166:in 'parse'
/tmp/hexapdf/lib/hexapdf/content/parser.rb:186:in 'parse'
<internal:kernel>:191:in 'loop'
/tmp/hexapdf/lib/hexapdf/content/parser.rb:192:1in

'with_document'
'block in execute'

'each'

'block in parse'

/tmp/hexapdf/lib/hexapdf/task/optimize.rb:289:in 'process'

== Tareackineg INEEEMAEILEN s————— e e e e e e e e e e e e e e e e
Total ractor count: 1

Ruby thread count for this ractor: 1

-— Machine register context -
RIP: 0x00005bc7£596320d RBP: 0x00005bc7f535cd18 RSP: 0x00007ffeb64795a0
RAX: 0x00000000000000b0 RBX: 0x00007b47a9%eff4a8 RCX: 0x00005bc7f£5315ee0
RDX: 0x0000000000000000 RDI: 0x0000000000000000 RSI: 0x0000000000000007

R8: 0x00007b478e8c56a8 R9: 0x00007b478e8934c8 R10: 0x64d5ad93872fbbfd

R11: 0x00005bc7£3b57£f50 R12: 0x00005bc7£5270470 R13: 0x00007b47a9ffeadl
R14: 0x00005bc7£535cd28 R15: 0x00007b47a9ffeb40 EFL: 0x0000000000010202

[0x5bc7£38c2bl3]

—-— C level backtrace information
/home/thomas/.rbenv/versions/3.4-dev/bin/ruby (rb_print_backtrace+0x14)
build.20240519133220.779813.90K1gU/ruby-master/vm_dump.c:820
/home/thomas/.rbenv/versions/3.4-dev/bin/ruby (rb_vm_bugreport)
13.90K1gU/ruby-master/vm_dump.c:1151

/tmp/ruby-

/tmp/ruby-build.20240519133220.7798

/home/thomas/.rbenv/versions/3.4-dev/bin/ruby (rb_bug_for_fatal_signal+0xfc) [0x5bc7f3a7796c] /tmp/
ruby-build.20240519133220.779813.90K1gU/ruby-master/error.c:1108
/home/thomas/.rbenv/versions/3.4-dev/bin/ruby (sigsegv+0x46) [0x5bc7£3806916] /tmp/ruby-build.20240

519133220.779813.90K1gU/ruby-master/signal.c:929
/1lib/x86_64-1linux—gnu/libc.so.6(0x7b47aa645320)
[0x5bc7£596320d]

[0x7b472aa645320]

—— Other runtime information
* Loaded script: bin/hexapdf

* Loaded features:

0 enumerator.so
1 thread.rb
2 fiber.so
3 rational.so
4 complex.so
5 ruby2_keywords.rb
6 /home/thomas/.rbenv/versions/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/enc/encdb.so
7 /home/thomas/.rbenv/versions/3.4-dev/lib/ruby/3.4.0+0/x86_64-1linux/enc/trans/transdb.so
8 /home/thomas/.rbenv/versions/3.4-dev/lib/ruby/3.4.0+0/x86_64-linux/rbconfig.rb
9 /home/thomas/.rbenv/versions/3.4-dev/1lib/ruby/3.4.0+0/rubygems/compatibility.rb
10 /home/thomas/.rbenv/versions/3.4-dev/1lib/ruby/3.4.0+0/rubygems/defaults.rb
11 /home/thomas/.rbenv/versions/3.4-dev/1lib/ruby/3.4.0+0/rubygems/deprecate.rb
12 /home/thomas/.rbenv/versions/3.4-dev/1lib/ruby/3.4.0+0/rubygems/errors.rb
13 /home/thomas/.rbenv/versions/3.4-dev/1ib/ruby/3.4.0+0/rubygems/unknown_command_spell_checker
.rb
14 /home/thomas/.rbenv/versions/3.4-dev/1ib/ruby/3.4.0+0/rubygems/exceptions.rb
15 /home/thomas/.rbenv/versions/3.4-dev/1lib/ruby/3.4.0+0/rubygems/basic_specification.rb
16 /home/thomas/.rbenv/versions/3.4-dev/1lib/ruby/3.4.0+0/rubygems/stub_specification.rb
05/12/2025 2/11




17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41

/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .
/home/thomas/ .

_checkers/class_name_checker.rb

rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.
rbenv/versions/3.

42 /home/thomas/.rbenv/versions/3.

_checkers/variable_name_checker.rb

43 /home/thomas/
_checkers.rb

44 /home/thomas/.
e_checker.rb

45 /home/thomas/.
er.rb
/tmp/hexapdf/lib/hexapdf/error.
/tmp/hexapdf/lib/hexapdf/data_dir.rb
/tmp/hexapdf/lib/hexapdf/content.rb
/home/thomas/.rbenv/versions/3.4-dev/1lib/ruby/3.
/tmp/hexapdf/lib/hexapdf/font/invalid_glyph.rb
/tmp/hexapdf/lib/hexapdf/configuration.rb
/tmp/hexapdf/lib/hexapdf/reference.rb
/tmp/hexapdf/lib/hexapdf/object.rb
/tmp/hexapdf/lib/hexapdf/pdf_array.rb
/home/thomas/.rbenv/versions/3.
/home/thomas/.rbenv/versions/3.
/home/thomas/.rbenv/versions/3.
/tmp/hexapdf/lib/hexapdf/rectangle.rb
/tmp/hexapdf/lib/hexapdf/utils/pdf_doc_encoding.
/tmp/hexapdf/lib/hexapdf/dictionary_fields.rb
/tmp/hexapdf/lib/hexapdf/dictionary.rb
/tmp/hexapdf/lib/hexapdf/filter.rb

4-dev/1lib/ruby/3.
4-dev/1lib/ruby/3.
4-dev/1lib/ruby/3.
4-dev/lib/ruby/3.
4-dev/1lib/ruby/3.
4-dev/1lib/ruby/3.
4-dev/lib/ruby/3.
4-dev/1lib/ruby/3.
4—-dev/lib/ruby/gems/3.4.0+0/gems/cmdparse-3.0.7/1ib/cmdparse.

4-dev/1lib/ruby/3.
4-dev/1lib/ruby/3.
4-dev/1lib/ruby/3.

rb

4-dev/lib/ruby/3.
4-dev/1lib/ruby/3.
4-dev/1lib/ruby/3.

BSOS D D D D D D D D D D D D D D D DD D S D D D D

4
4.
4

4.

.0+0/rubygems/platform.rb
.0+0/rubygems/specification_record.rb
.0+0/rubygems/util/list.rb
.0+0/rubygems/version.rb
.0+0/rubygems/requirement.rb
.0+0/rubygems/specification.rb
.0+0/rubygems/util.rb
.0+0/rubygems/dependency.rb
.0+0/rubygems/core_ext/kernel_gem.rb
.04+0/x86_64-1inux/monitor.so
.0+0/monitor.rb

.0+0/rubygems.rb

.0+0/bundled_gems.rb
.0+0/rubygems/path_support.rb
.0+0/error_highlight/version.rb
.0+0/error_highlight/base.rb
.0+0/error_highlight/formatter.rb
.0+0/error_highlight/core_ext.rb
.0+0/error_highlight.rb
.0+0/did_you_mean/version.rb
.0+0/did_you_mean/core_ext/name_error.rb
.0+0/did_you_mean/levenshtein.rb
.0+0/did_you_mean/jaro_winkler.rb
.0+0/did_you_mean/spell_checker.rb
.0+0/did_you_mean/spell_checkers/name_error

.0+0/did_you_mean/spell_checkers/name_error
.0+0/did_you_mean/spell_checkers/name_error
.0+0/did_you_mean/spell_checkers/method_nam
.0+0/did_you_mean/spell_checkers/key_error_
.0+0/did_you_mean/spell_checkers/null_check

.0+0/did_you_mean/tree_spell_checker.rb
.0+0/did_you_mean/spell_checkers/require_pa

.0+0/did_you_mean/spell_checkers/pattern_ke

.0+0/did_you_mean/formatter.rb

0+0/did_you_mean.rb

.0+0/syntax_suggest/core_ext.rb

0+0/optparse.rb

.0+0/x86_64-1inux/io/console.so
.0+0/ostruct.rb
.0+0/x86_64-1inux/stringio.so

.0+0/set.rb

.0+0/x86_64-1linux/date_core.so
.0+0/date.rb
.0+0/time.rb
/tmp/hexapdf/lib/hexapdf/stream.rb
/home/thomas/.rbenv/versions/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1linux/strscan.so
/tmp/hexapdf/lib/hexapdf/tokenizer.rb
/tmp/hexapdf/lib/hexapdf/utils/object_hash.rb
/tmp/hexapdf/lib/hexapdf/xref_section.rb
/tmp/hexapdf/lib/hexapdf/parser.rb
/tmp/hexapdf/lib/hexapdf/revision.rb
/home/thomas/.rbenv/versions/3.4-dev/1ib/ruby/3.
/home/thomas/.rbenv/versions/3.4-dev/1ib/ruby/3.
/home/thomas/.rbenv/versions/3.4-dev/1ib/ruby/3.
/home/thomas/.rbenv/versions/3.4-dev/1lib/ruby/3.
/home/thomas/.rbenv/versions/3.4-dev/1lib/ruby/3.
/tmp/hexapdf/lib/hexapdf/type/trailer.rb
/tmp/hexapdf/lib/hexapdf/revisions.rb
/tmp/hexapdf/lib/hexapdf/type/actions.rb
/tmp/hexapdf/lib/hexapdf/type/annotations.rb
/tmp/hexapdf/lib/hexapdf/type.rb
/tmp/hexapdf/lib/hexapdf/task.rb
/tmp/hexapdf/lib/hexapdf/encryption.rb
/tmp/hexapdf/lib/hexapdf/utils/lru_cache.rb
/tmp/hexapdf/lib/hexapdf/serializer.rb
/tmp/hexapdf/lib/hexapdf/version.rb
/tmp/hexapdf/lib/hexapdf/writer.rb
/home/thomas/.rbenv/versions/3.4-dev/1ib/ruby/3.4.0+0/delegate.rb
/home/thomas/.rbenv/versions/3.4-dev/1ib/ruby/3.4.0+0/weakref.rb
/tmp/hexapdf/lib/hexapdf/importer.rb

/tmp/hexapdf/lib/hexapdf/image_loader.rb

/tmp/hexapdf/lib/hexapdf/font_loader.rb

/tmp/hexapdf/lib/hexapdf/layout.rb

/tmp/hexapdf/lib/hexapdf/digital_signature.rb
/home/thomas/.rbenv/versions/3.4-dev/1lib/ruby/gems/3.4.0+0/gems/geom2d-0.4.1/1ib/geom2d/util

.0+0/digest/version.rb
.0+0/x86_64-1inux/digest.so
.0+0/digest/loader.rb
.0+0/digest.rb
.0+0/x86_64-1inux/digest/md5. so

B DS S

/tmp/hexapdf/lib/hexapdf/utils.rb
/tmp/hexapdf/lib/hexapdf/document.rb
/tmp/hexapdf/lib/hexapdf/font/true_type.rb
/tmp/hexapdf/lib/hexapdf/cli/command.rb
/tmp/hexapdf/lib/hexapdf/cli/info.rb
/tmp/hexapdf/lib/hexapdf/cli/files.rb
/tmp/hexapdf/lib/hexapdf/content/color_space.rb
/tmp/hexapdf/lib/hexapdf/utils/math_helpers.rb
/tmp/hexapdf/lib/hexapdf/content/transformation_matrix.rb
/tmp/hexapdf/lib/hexapdf/content/graphics_state.rb
/tmp/hexapdf/lib/hexapdf/content/operator.rb
/tmp/hexapdf/lib/hexapdf/content/processor.rb
/tmp/hexapdf/lib/hexapdf/cli/inspect.rb
/tmp/hexapdf/lib/hexapdf/cli/modify.rb
/tmp/hexapdf/lib/hexapdf/cli/merge.rb
/tmp/hexapdf/lib/hexapdf/cli/optimize.rb
/tmp/hexapdf/lib/hexapdf/cli/images.rb
/home/thomas/.rbenv/versions/3.4-dev/1ib/ruby/3.4.0+0/shellwords.rb
/tmp/hexapdf/lib/hexapdf/cli/batch.rb
/tmp/hexapdf/lib/hexapdf/cli/split.rb
/tmp/hexapdf/lib/hexapdf/cli/watermark.rb
/tmp/hexapdf/lib/hexapdf/cli/image2pdf.rb
/tmp/hexapdf/lib/hexapdf/cli/form.rb
/tmp/hexapdf/lib/hexapdf/cli/fonts.rb
/tmp/hexapdf/lib/hexapdf/cli/usage.rb
/tmp/hexapdf/lib/hexapdf/cli.rb
/tmp/hexapdf/lib/hexapdf/encryption/security_handler.rb
/home/thomas/.rbenv/versions/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1inux/digest/sha2.so
/home/thomas/.rbenv/versions/3.4-dev/1lib/ruby/3.4.0+0/digest/sha2/loader.rb
/home/thomas/.rbenv/versions/3.4-dev/1ib/ruby/3.4.0+0/digest/sha2.rb
/tmp/hexapdf/lib/hexapdf/encryption/standard_security_handler.rb
/tmp/hexapdf/lib/hexapdf/type/page_tree_node.rb
/tmp/hexapdf/lib/hexapdf/document /pages.rb
/tmp/hexapdf/lib/hexapdf/utils/sorted_tree_node.rb
/tmp/hexapdf/lib/hexapdf/number_tree_node.rb
141 /tmp/hexapdf/lib/hexapdf/type/catalog.rb

142 /tmp/hexapdf/lib/hexapdf/type/page.rb

143 /tmp/hexapdf/lib/hexapdf/type/resources.rb

144 /tmp/hexapdf/lib/hexapdf/font/cmap.rb

145 /tmp/hexapdf/lib/hexapdf/type/font.rb

146 /tmp/hexapdf/lib/hexapdf/font/encoding.rb

147 /tmp/hexapdf/lib/hexapdf/type/font_simple.rb
148 /tmp/hexapdf/lib/hexapdf/font/typel.rb

149 /tmp/hexapdf/lib/hexapdf/font/typel_wrapper.rb
150 /tmp/hexapdf/lib/hexapdf/type/font_typel.rb

151 /home/thomas/.rbenv/versions/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/z1lib.so
152 /tmp/hexapdf/lib/hexapdf/type/image.rb

153 /tmp/hexapdf/lib/hexapdf/utils/bit_field.rb

154 /tmp/hexapdf/lib/hexapdf/type/annotation.rb

155 /tmp/hexapdf/lib/hexapdf/type/annotations/link.rb
156 /tmp/hexapdf/lib/hexapdf/type/outline.rb

157 /tmp/hexapdf/lib/hexapdf/content/parser.rb

158 /tmp/hexapdf/lib/hexapdf/type/xref_stream.rb
159 /tmp/hexapdf/lib/hexapdf/type/object_stream.rb
160 /tmp/hexapdf/lib/hexapdf/task/optimize.rb

161 /tmp/hexapdf/lib/hexapdf/utils/bit_stream.rb
162 /tmp/hexapdf/lib/hexapdf/filter/predictor.rb
163 /tmp/hexapdf/lib/hexapdf/filter/flate_decode.rb

* Process memory map:

5bc7£3687000-5bc7£36cb000 r——p 00000000 fc:01 27662520 /home/thomas/ .

ons/3.4-dev/bin/ruby

S5bc7£36cb000-5bc7£3b27000 r-xp 00044000 fc:01 27662520 /home/thomas/ .

ons/3.4-dev/bin/ruby

5bc7£3b27000-5bc7£3cc4000 r——-p 004a0000 fc:01 27662520 /home/thomas/ .

ons/3.4-dev/bin/ruby

5bc7£3cc4000-5bc7£3cdc000 r——p 0063d000 fc:01 27662520 /home/thomas/ .

ons/3.4-dev/bin/ruby

5bc7£3cdc000-5bc7£3cdd000 rw-p 00655000 fc:01 27662520 /home/thomas/ .

ons/3.4-dev/bin/ruby
5bc7£3cdd000-5bc7£3c£2000 rw-p 00000000 00:00
5bc7£5267000-5bc7£58cb000 rw-p 00000000 00:00
5bc7£58e7000-5bc7£5972000 r-xp 00000000 00:00
5bc7£5972000-5bc7£88e7000 ——-p 00000000 00:00
7b478a45a000-70478a600000 rw—-p 00000000 00:00
7b478b000000-7b478b207000 r—-s 00000000 fc:01
/libc.so.6

7b478b2£2000-70478b400000 rw-p 00000000 00:00 O

[heap]

P O O O O O

7b478b400000-70478e416000 r—-s 00000000 fc:01 27662520 /home/thomas/ .

ons/3.4-dev/bin/ruby

7b478e4df000-70478e821000 rw-p 00000000 00:00
7b478e880000-70478ea00000 rw—-p 00000000 00:00
7b478ea00000-70478ea01000 ———p 00000000 00:00
7b478ea01000-7b478eaa2000 rw-p 00000000 00:00
7b478eaa2000-7b478eaa3000 —-——p 00000000 00:00
70478eaa3000-7b478eb44000 rw-p 00000000 00:00
70b478eb44000-70478eb45000 ———-p 00000000 00:00
7b478eb45000-7b478ebe6000 rw-p 00000000 00:00
7b478ebe6000-7b478ebe7000 ——-p 00000000 00:00
7b478ebe7000-70478ec88000 rw-p 00000000 00:00
7b478ec88000-70b478ec89000 ———p 00000000 00:00
7b478ec89000-7b478ed2a000 rw-p 00000000 00:00
7b478ed2a000-7b478ed2b000 —---p 00000000 00:00
70478ed2b000-7b478edcc000 rw-p 00000000 00:00
7b478edcc000-7b478edcd000 ——-p 00000000 00:00
70478edcd000-7b478ee6e000 rw-p 00000000 00:00
7b478ee6e000-70478ee6f000 ———p 00000000 00:00
7b478ee6f000-70478e£10000 rw-p 00000000 00:00
7b478ef£10000-70478e£11000 ———p 00000000 00:00
7b478e£11000-7b478e£fb2000 rw-p 00000000 00:00
7b478efb2000-7b478e£fb3000 —-——p 00000000 00:00

O O O O O O O O OO OO OO oo oo oo
7b478efb3000-70478£054000 rw—-p 00000000 00:00
7b478£054000-70478£055000 ———p 00000000 00:00
7b478£055000-70478£0£6000 rw—p 00000000 00:00
7Tb478f0£f6000-70478£f0£7000 ———p 00000000 00:00
Tb478f0£7000-70478£198000 rw—p 00000000 00:00
7b478£198000-7b478£199000 ———p 00000000 00:00
Tb478£199000-70478£23a000 rw—-p 00000000 00:00
7b478£23a000-70478£23b000 ——-p 00000000 00:00
7b478£23b000-70478£2dc000 rw—p 00000000 00:00
7b478£2dc000-70478£2dd000 ———p 00000000 00:00
7b478£2dd000-70478£37e000 rw—-p 00000000 00:00
Tb478£37e000-70478£37£f000 ———p 00000000 00:00
Tb478£37£000-7b478£420000 rw—p 00000000 00:00
Tb478£f420000-70478£421000 ———p 00000000 00:00
Tb478£421000-70478£4c2000 rw—p 00000000 00:00
Tb478f4c2000-70478£4c3000 ——-p 00000000 00:00
Tb478£4c3000-70478£564000 rw—p 00000000 00:00
7b478£564000-7b478£565000 ———p 00000000 00:00
Tb478£565000-70478£606000 rw—p 00000000 00:00
7b478f606000-70478£607000 ———p 00000000 00:00
Tb478f607000-70478f6a8000 rw—p 00000000 00:00
7b478f6a8000-7b478£6a9000 ———p 00000000 00:00
Tb478f6a9000-70478£74a000 rw—p 00000000 00:00
Tb478£74a000-70478£74b000 ——-p 00000000 00:00
Tb478£74b000-70478£f7ec000 rw—p 00000000 00:00
Tb478£7ec000-7b478£7ed000 ———p 00000000 00:00
Tb478£7ed000-70478£88e000 rw—p 00000000 00:00
7b478f88e000-7b478£88f000 ———p 00000000 00:00
Tb478f88f000-7b478£930000 rw—p 00000000 00:00
7b478£930000-70478£931000 ———p 00000000 00:00
7b478£931000-70478£9d2000 rw-p 00000000 00:00
7b478£9d2000-7b478£9d3000 ——-p 00000000 00:00
7b478£9d3000-70478£fa74000 rw—-p 00000000 00:00
7b478£fa74000-70478£fa75000 ———p 00000000 00:00
7b478£fa75000-70478£fb16000 rw—p 00000000 00:00
7b478fb16000-70478fb17000 ———p 00000000 00:00
Tb478fb17000-70478fbb8000 rw—p 00000000 00:00
Tb478fbb8000-7b478fbb9000 ———p 00000000 00:00
Tb478fbb9000-7b478fc5a000 rw—-p 00000000 00:00
Tb478fc5a000-7b478£fc5b000 ——-p 00000000 00:00
7b478£c5p000-70478fcfc000 rw—p 00000000 00:00
Tb478fcfc000-7b478£fcfd000 ———p 00000000 00:00
Tb478fcfd000-70478£d9e000 rw—-p 00000000 00:00
7b478£fd9%9e000-7b478£fd9f000 ———p 00000000 00:00
Tb478fd9f000-7b478fe40000 rw—p 00000000 00:00
Tb478fe50000-7b478fed0000 rw—-p 00000000 00:00
Tb478fedf000-704790000000 rw—-p 00000000 00:00
7b4790000000-704790001000 ——-p 00000000 00:00
7b4790001000-704790801000 rw—-p 00000000 00:00
70479080c000-70479080£f000 r—-p 00000000 fc:01 27662532
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1inux/zlib.so
7b479080f000-70479081b000 r—-xp 00003000 fc:01 27662532
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1inux/zlib.so
7b479081b000-70479081e000 r——p 0000£000 fc:01 27662532
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1inux/zlib.so
7b479081e000-70479081£f000 r—-p 00011000 fc:01 27662532
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1inux/zlib.so
7b479081£000-704790820000 rw-p 00012000 fc:01 27662532
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1inux/zlib.so
7b4790820000-704790830000 rw—p 00000000 00:00 O
7b4790840000-704790880000 rw—p 00000000 00:00 O
7b4790882000-704790885000 r——p 00000000 fc:01 27662535
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/date_core.so
7b4790885000-7047908b5000 r-xp 00003000 fc:01 27662535
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/date_core.so
7b47908b5000-7047908bd000 r—-p 00033000 fc:01 27662535
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/date_core.so

O O O O O O O O O O OO OO OO OO OO OO OO OO OO0 0O0O0OOO0OOOOLOLOOLOOLOLOOOOO OO Oo
7b47908bd000-7047908be000 r——p 0003b000 fc:01 27662535
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/date_core.so
Tb47908be000-7b47908b£f000 rw-p 0003c000 fc:01 27662535
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1linux/date_core.so
7b47908bf000-7047a9e00000 rw-p 00000000 00:00 O
7047a9e01000-7047a9e02000 r—-p 00000000 fc:01 27824240
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1inux/digest/sha2.so
7b47a9e02000-7047a9e06000 r—-xp 00001000 fc:01 27824240
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1inux/digest/sha2.so
Tb47a9e06000-7b47a9e07000 r—--p 00005000 fc:01 27824240
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1inux/digest/sha2.so
7047a9e07000-7047a9e08000 r—-p 00005000 fc:01 27824240
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1inux/digest/sha2.so
7047a9e08000-7047a9e09000 rw-p 00006000 fc:01 27824240
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1inux/digest/sha2.so
7047a9e09000-7047a9e0b000 r——p 00000000 fc:01 27662545
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/digest.so
Tb47a9e0b000-7b47a9e0d000 r-xp 00002000 fc:01 27662545
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1inux/digest.so
7047a9e0d000-7047a9e0e000 r—--p 00004000 fc:01 27662545
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1inux/digest.so
7047a9e0e000-7047a9e0£000 r—-p 00004000 fc:01 27662545
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/digest.so
7b47a9e0£f000-7047a9e10000 rw-p 00005000 fc:01 27662545
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/digest.so
7b47a9e10000-7b47a9e30000 rw-p 00000000 00:00 O
Tb47a9e36000-7b47a9e38000 r—--p 00000000 fc:01 27662544
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1inux/strscan.so
7b47a9e38000-70b47a9e3c000 r-xp 00002000 fc:01 27662544
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1inux/strscan.so
7b47a9e3c000-7b47a9e3e000 r——-p 00006000 fc:01 27662544
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1inux/strscan.so
7b47a9e3e000-7047a9e3£f000 r——p 00007000 fc:01 27662544
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/strscan.so
Tb47a9e3£000-7b47a9e40000 rw-p 00008000 fc:01 27662544
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1inux/strscan.so
7047a9e40000-7047a9e£f0000 rw-p 00000000 00:00 O
7Tb47a9e£3000-7047a9e£6000 r——p 00000000 fc:01 27662547
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1inux/stringio.so
Tb47a9ef6000-7b47a9efb000 r—-xp 00003000 fc:01 27662547
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/stringio.so
Tb47a9efb000-7b47a9e£d000 r--p 00008000 fc:01 27662547
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1inux/stringio.so
7b47a9e£fd000-7b47a9%9efe000 r—-p 00009000 fc:01 27662547
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1inux/stringio.so
Tb47a9efe000-7047a9ef£f000 rw-p 0000a000 fc:01 27662547
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/stringio.so
7Tb47a9ef£f000-7047aa000000 rw—p 00000000 00:00 O
7b47aa000000-7b47aa5ce000 r——p 00000000 fc:01 19139801
chive

Tb47aa5d1000-7b47aa5d2000 r--p 00000000 fc:01 27824237
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1inux/digest/md5.so
Tb47aa5d2000-7b47aa5d3000 r-xp 00001000 fc:01 27824237
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1inux/digest/md5.so
7Tb47aa5d3000-7b47aa5d4000 r—-p 00002000 fc:01 27824237
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1inux/digest/md5.so
Tb47aa5d4000-7b47aa5d5000 r——p 00002000 fc:01 27824237
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/digest/md5.so
Tb47aa5d5000-7b47aa5d6000 rw-p 00003000 fc:01 27824237
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1inux/digest/md5.so
7b47aa5d6000-7047aa5d8000 r—-p 00000000 fc:01 28313083
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/io/console.so
7b47aa5d8000-7b47aa5dd000 r-xp 00002000 fc:01 28313083
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/io/console.so
7b47aa5dd000-7b47aa5de000 r——p 00007000 fc:01 28313083
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/io/console.so
Tb47aa5de000-7b47aa5df000 r--p 00008000 fc:01 28313083
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/io/console.so
7b472a5df000-7b47aa5e0000 rw-p 00009000 fc:01 28313083
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1inux/io/console.so
7b47aa5e0000-7047aa600000 rw-p 00000000 00:00 O
7b472a600000-70472a628000 r—-p 00000000 fc:01 19160552
/libc.so.6

7b472a628000-7047aa7b0000 r—-xp 00028000 fc:01 19160552
/libc.so0.6

7b47aa7p0000-7b47aa7£f£000 r——p 001b0000 fc:01 19160552
/libc.so.6

Tb47aa7££000-7b47aa803000 r—--p 001£fe000 fc:01 19160552
/libc.so.6

Tb47aa803000-7047aa805000 rw-p 00202000 fc:01 19160552
/libc.so.6

7b472a805000-7047aa812000 rw-p 00000000 00:00 O
7b472a812000-7047aa813000 r—-p 00000000 fc:01 27662541
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/monitor.so
7b472a813000-7b47aa814000 r-xp 00001000 fc:01 27662541
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1inux/monitor.so
7b47aa814000-7047aa815000 r—-p 00002000 fc:01 27662541
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1inux/monitor.so
7b472a815000-7047aa816000 r——-p 00002000 fc:01 27662541
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1inux/monitor.so
7b472a816000-7b47aa817000 rw-p 00003000 fc:01 27662541
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/monitor.so
7b472a817000-7b47aa87d000 rw-p 00000000 00:00 O
7b47aa87d000-7047aa881000 r—-p 00000000 fc:01 19139620
/libgcc_s.so.1

7b472a881000-7047aa8a4000 r—-xp 00004000 fc:01 19139620
/libgcc_s.so.1

7b47aa8a4000-7b47aa8a8000 r—-p 00027000 fc:01 19139620
/libgcc_s.so.1

7b472aa8a8000-7b47aa8a9000 r——p 0002b000 fc:01 19139620
/libgcc_s.so.1l

Tb47aa8a9000-7b47aa8aal000 rw-p 0002c000 fc:01 19139620
/libgcc_s.so.1

7b47aa8aa000-7b47aa8bal000 r—-p 00000000 fc:01 19160558
/libm.so.6

7b47aa8ba000-7047aa939000 r—-xp 00010000 fc:01 19160558
/libm.so.6

7b472a2939000-7047aa991000 r——p 0008£000 fc:01 19160558
/libm.so.6

7b47aa991000-7047aa992000 r—--p 000e7000 fc:01 19160558
/libm.so.6

7b472a992000-70472a993000 rw-p 000e8000 fc:01 19160558
/libm.so.6

7b47aa993000-7047a2a2995000 r—-p 00000000 fc:01 19139159
/libcrypt.so.1.1.0

7b472a995000-7b47aa9%9aal000 r—-xp 00002000 fc:01 19139159
/libcrypt.so.1.1.0

7b47aa9%9aa000-7b47aa9c3000 r—-p 00017000 fc:01 19139159
/libcrypt.so.1.1.0

7b47aa9c3000-7047aa9c4000 r—-p 0002£f000 fc:01 19139159
/libcrypt.so.1.1.0

7b47aa9c4000-7047aa9c5000 rw-p 00030000 fc:01 19139159
/libcrypt.so.1.1.0

7b47aa9c5000-7b47aa9cd000 rw—p 00000000 00:00 O
7b472a9cd000-7b47aa9d7000 r—--p 00000000 fc:01 19137956
/libgmp.s0.10.5.0

7047aa9d7000-7b47aaa3a000 r-xp 0000a000 fc:01 19137956
/libgmp.s0.10.5.0

Tb47aaa3a000-7b47aaa4£f000 r—--p 0006d000 fc:01 19137956
/libgmp.s0.10.5.0

Tb47aaa4£000-7b47aaa50000 r—-p 00081000 fc:01 19137956
/libgmp.s0.10.5.0

7b47aaa50000-7b47a2a2a51000 rw-p 00082000 fc:01 19137956
/libgmp.s0.10.5.0
7b4722a51000-7b47aaa53000 r——p 00000000 fc:01 19137328
/libz.so0.1.3
Tb47aaa53000-7b47aaa65000 r-xp 00002000 fc:01 19137328
/libz.s0.1.3
Tb47aaa65000-7b47aaa6b000 r—--p 00014000 fc:01 19137328
/libz.so0.1.3
7b47aaa6b000-7b47aaa6c000 r--p 0001a000 fc:01 19137328
/libz.so0.1.3
Tbd47aaa6c000-7b47aaa6d000 rw—p 0001b000 fc:01 19137328
/libz.so0.1.3
Tb472aaa6f000-7b47aaa70000 r--p 00000000 fc:01 27824269

ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/enc/trans/transdb.

7b47aaa70000-7b47aaa71000 r-xp 00001000 fc:01 27824269

ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/enc/trans/transdb.

Tb47aaa71000-7b47aaa72000 r--p 00002000 fc:01 27824269

ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/enc/trans/transdb.

Tb47aaa72000-7b47aaa73000 r—--p 00002000 fc:01 27824269

ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/enc/trans/transdb.

Tb47aaa73000-7b47aaa74000 rw-p 00003000 fc:01 27824269

ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/enc/trans/transdb.

Tb47aaa74000-7b47aaa75000 r—-p 00000000 fc:01 27824254
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/enc/encdb.so
Tb47aaa75000-7b47aaa76000 r-xp 00001000 fc:01 27824254
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/enc/encdb.so
Tb47aaa76000-7b47aaa77000 r——p 00002000 fc:01 27824254
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/enc/encdb.so
Tb47aaa77000-7b47aaa78000 r--p 00002000 fc:01 27824254
ons/3.4-dev/1ib/ruby/3.4.0+0/x86_64-1linux/enc/encdb.so
Tb47aaa78000-7b47aaa79000 rw-p 00003000 fc:01 27824254
ons/3.4-dev/1lib/ruby/3.4.0+0/x86_64-1linux/enc/encdb.so
Tb47aaa79000-7b47aaa80000 r—--s 00000000 fc:01 19160541
/gconv/gconv-modules.cache

7b4722a80000-7b47aaa90000 rw—p 00000000 00:00 O
7b4722a91000-7b4722a93000 rw-p 00000000 00:00 O
Tb47aa2a93000-7b47a2a2a294000 r——p 00000000 fc:01 19160549
/1d-1inux-x86-64.s50.2

7b47aaa94000-7b47aaabf000 r-xp 00001000 fc:01 19160549
/1d-1linux-x86-64.s0.2

TbdT7aaabf000-7b47aaac9000 r-——p 0002c000 fc:01 19160549
/1d-1linux-x86-64.s0.2

Tb47aaac9000-7b47aaacb000 r——p 00036000 fc:01 19160549
/1ld-1linux-x86-64.s0.2

Tb47aaacb000-7b47aaacd000 rw-p 00038000 fc:01 19160549
/1d-1inux-x86-64.s50.2

7ffeb5c7e000-7ffeb647d000 rw—p 00000000 00:00 O
7ffeb65b1000-7ffeb65b5000 r——p 00000000 00:00 O
7ffeb65b5000-7ffeb65b7000 r-xp 00000000 00:00 O
fEffffffff600000-££££££££££f601000 ——xp 00000000 00:00 O

SO

SO

SO

SO

SO

/usr/1ib/x86_64-1linux—gnu
/usr/1lib/x86_64-1linux—gnu
/usr/1lib/x86_64-1inux—gnu
/usr/1ib/x86_64-1linux—gnu
/usr/1lib/x86_64-1linux—gnu
/home/thomas/.rbenv/versi
/home/thomas/.rbenv/versi
/home/thomas/.rbenv/versi
/home/thomas/.rbenv/versi
/home/thomas/.rbenv/versi
/home/thomas/.rbenv/versi
/home/thomas/.rbenv/versi
/home/thomas/.rbenv/versi
/home/thomas/.rbenv/versi
/home/thomas/.rbenv/versi

/usr/1ib/x86_64-1linux—gnu

/usr/1ib/x86_64-1linux—gnu
/usr/1lib/x86_64-1linux—gnu
/usr/1ib/x86_64-1linux—gnu
/usr/1ib/x86_64-1linux—gnu
/usr/1lib/x86_64-1linux—gnu
stack]
vvar]

[
[
[vdso]
[vsyscall]

Associated revisions

Revision 6c8ae44a388e5c03b7db90376af3652007b574e8 - 05/31/2024 10:37 PM - alanwu (Alan Wu)

YJIT: Fix out of bounds access when splatting empty array

Previously, we read the last element array even when the array was
empty, doing an out-of-bounds access. This sometimes caused a SEGV.

[Bug #20496]

Revision 6¢c8ae44a388e5c03b7db90376af3652007b574e8 - 05/31/2024 10:37 PM - alanwu (Alan Wu)

YJIT: Fix out of bounds access when splatting empty array

Previously, we read the last element array even when the array was
empty, doing an out-of-bounds access. This sometimes caused a SEGV.

[Bug #20496]
Revision 6¢c8aed44a - 05/31/2024 10:37 PM - alanwu (Alan Wu)

YJIT: Fix out of bounds access when splatting empty array

Previously, we read the last element array even when the array was
empty, doing an out-of-bounds access. This sometimes caused a SEGV.

[Bug #20496]
Revision b74f669e2fbe5c63409878e7a9f9d39c85541f77 - 06/04/2024 08:17 PM - alanwu (Alan Wu)
YJIT: Fix out of bounds access when splatting empty array (#10905)

This is a backport of 6¢c8ae44a388e5c03b7db90376af3652007b574e8 with a
test tailored to crash the 3.3.x branch (from GH-10904).

Previously, we read the last element array even when the array was
empty, doing an out-of-bounds access. This sometimes caused a SEGV.

[Bug #20496]
Revision b74f669e2fbe5c63409878e7a9f9d39c85541f77 - 06/04/2024 08:17 PM - alanwu (Alan Wu)
YJIT: Fix out of bounds access when splatting empty array (#10905)

This is a backport of 6c8ae44a388e5c03b7db90376af3652007b574e8 with a
test tailored to crash the 3.3.x branch (from GH-10904).

Previously, we read the last element array even when the array was
empty, doing an out-of-bounds access. This sometimes caused a SEGV.

[Bug #20496]
Revision b74f669e - 06/04/2024 08:17 PM - alanwu (Alan Wu)
YJIT: Fix out of bounds access when splatting empty array (#10905)

This is a backport of 6c8ae44a388e5c03b7db90376af3652007b574e8 with a
test tailored to crash the 3.3.x branch (from GH-10904).

Previously, we read the last element array even when the array was
empty, doing an out-of-bounds access. This sometimes caused a SEGV.

[Bug #20496]

History

#1 - 05/20/2024 08:17 AM - kOkubun (Takashi Kokubun)
- Status changed from Open to Assigned

- Assignee set to jit

#2 - 05/31/2024 10:37 PM - alanwu (Alan Wu)

- Status changed from Assigned to Closed

Applied in changeset git|6c8ae44a388e5c03b7db90376af3652007b574e8.

YJIT: Fix out of bounds access when splatting empty array

Previously, we read the last element array even when the array was
empty, doing an out-of-bounds access. This sometimes caused a SEGV.

[Bug #20496]
#3 - 05/31/2024 11:35 PM - alanwu (Alan Wu)
The linked commit fixed the issue for me locally; feel free to re-test.

Thanks for the comprehensive report!

#4 - 06/04/2024 08:18 PM - kOkubun (Takashi Kokubun)

- Backport changed from 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN to 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: DONE
https://redmine.ruby-lang.org/projects/ruby-master/repository/git/revisions/6c8ae44a388e5c03b7db90376af3652007b574e8
